Program Disass;

Uses
	Crt,Objects;

Const
	Bin : Array[0..15] Of Word = (1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768);
	Dez : Array[0.. 4] Of Word = (1,10,100,1000,10000);
	Hex : Array[0.. 3] Of Word = (1,16,256,4096);
	HexText : Array[0..15] Of Char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');
	CommandText : Array[1..16] Of String[4] =
	('ADD ','NOR ','ROR ','ROL ',
	 'SUB ','AND ','RORC','ROLC',
	 'ADDC','EOR ','ASR ','ASL ',
	 'SUBC','OR  ','LSR ','BSWP');
	ConditionText : Array[1..17] Of String[2] =
	('ME','PE','HI','LS','CC','CS','NE','EQ',
	 'VC','VS','PL','MI','GE','LT','GT','LE',
	 'TR');
	FlagText : Array[1..2] Of String[2] =
	('HF','SF');

Function Prozent(p : Byte) : String;
Var
	Hilf : String;
Begin
	Hilf:=Copy('',1,    p*80 Div 100 )
	+Copy('',1,80-(p*80 Div 100));
	Prozent:=Hilf;
End;


Function  Swap(w : Word): Word;
Begin
	Swap:=(w shr 8)+((w and 255) shl 8);
End;

Function DecStr(aw : Word) : String;
Var
	i : Byte;
	Hilf : String[5];
	n : Boolean;
Begin
	Hilf:='';n:=False;
	For i:=4 Downto 0 Do
	If ((aw Div Dez[i]) Mod 10)=0 Then
	Begin
		If n Or (i=0) Then Hilf:=Hilf+'0' Else Hilf:=Hilf+' ';
	End Else
	Begin
		Hilf:=Hilf+HexText[(aw Div Dez[i]) Mod 10];
		n:=True;
	End;
	DecStr:=Hilf;
End;

Function HexStr(aw : Word) : String;
Var
	i : Byte;
	Hilf : String[16];
Begin
	Hilf:='';
	For i:=0 To 3 Do
	Hilf:=HexText[(aw Div Hex[i]) Mod 16]+Hilf;
	HexStr:=Hilf;
End;

Function BinStr(aw : Word) : String;
Var
	i : Byte;
	Hilf : String[16];
Begin
	Hilf:='';
	For i:=0 To 15 Do
	Hilf:=HexText[(aw Div Bin[i]) Mod 2]+Hilf;
	BinStr:=Hilf;
End;


Var
	a,b : tBufStream;
	i,p,l,w,x,y,z : Word;
	t : String;

Begin
	If ParamCount<>2 Then Exit;
	ClrScr;
	a.Init(ParamStr(1),stOpen,8192);
	b.Init(ParamStr(2),stCreate,8192);

	a.Read(p,Sizeof(p));p:=Swap(p);
	a.Read(l,Sizeof(l));l:=Swap(l);

	i:=0;
	While a.Status=0 Do
	Begin
		t:='';

		If i<l Then
		Begin
			a.Read(w,Sizeof(w));w:=Swap(w);Inc(i);

			t:=t+CommandText[(w And 15)+1]+' ';

			If (w And 2048)=0 Then
			Begin
				t:=t+ConditionText[(w shr 12)+1]+' ';
			End Else
			Begin
				t:=t+ConditionText[17]+' ';
			End;

			If (w And 1024)=0 Then t:=t+FlagText[1]+' ' Else t:=t+FlagText[2]+' ';

			If (w And 2048)<>0 Then
			Begin
				If (w And 32768)<>0 Then t:=t+'~' Else t:=t+' ';
				If (w And 16384)<>0 Then t:=t+'@' Else t:=t+' ';
			End Else t:=t+'  ';

			If (w And 48)=0 Then
			Begin
				t:=t+'     - ,';
			End Else
			If (w And 48)=16 Then
			Begin
				a.Read(x,SizeOf(x));x:=Swap(x);Inc(i);
				t:=t+'#$'+HexStr(x)+' ,'
			End Else
			If (w And 48)=32 Then
			Begin
				a.Read(x,SizeOf(x));x:=Swap(x);Inc(i);
				t:=t+' $'+HexStr(x)+' ,'
			End Else
			If (w And 48)=48 Then
			Begin
				a.Read(x,SizeOf(x));x:=Swap(x);Inc(i);
				t:=t+'($'+HexStr(x)+'),'
			End;


			If (w And 192)=0 Then
			Begin
				t:=t+'     - ,';
			End Else
			If (w And 192)=64 Then
			Begin
				a.Read(y,SizeOf(y));y:=Swap(y);Inc(i);
				t:=t+'#$'+HexStr(y)+' ,'
			End Else
			If (w And 192)=128 Then
			Begin
				a.Read(y,SizeOf(y));y:=Swap(y);Inc(i);
				t:=t+' $'+HexStr(y)+' ,'
			End Else
			If (w And 192)=192 Then
			Begin
				a.Read(y,SizeOf(y));y:=Swap(y);Inc(i);
				t:=t+'($'+HexStr(y)+'),'
			End;

			If (w And 2048)<>0 Then
			Begin
				If (w And  8192)<>0 Then t:=t+'~' Else t:=t+' ';
				If (w And  4096)<>0 Then t:=t+'@' Else t:=t+' ';
			End Else t:=t+'  ';



			If (w And 768)=0 Then
			Begin
				t:=t+'     - ';
			End Else
			If (w And 768)=256 Then
			Begin
				t:=t+'     = '
			End Else
			If (w And 768)=512 Then
			Begin
				a.Read(z,SizeOf(z));z:=Swap(z);Inc(i);
				t:=t+' $'+HexStr(z)+' '
			End Else
			If (w And 768)=768 Then
			Begin
				a.Read(z,SizeOf(z));z:=Swap(z);Inc(i);
				t:=t+'($'+HexStr(z)+') '
			End;
		End Else
		Begin
			a.Read(w,SizeOf(w));
			t:=HexStr(w);
		End;

		GotoXY(1,1);Write(Prozent(a.GetPos*100 Div l));
{		GotoXY(1,4);WriteLn(t);}

		t:=t+#13;
		b.Write(t[1],Length(t));
	End;
	b.Done;
	a.Done;
End.